Struts2 再爆高危漏洞S2-048 来了


Jul 08 2017

Struts2 再爆高危漏洞S2-048 来了

首页 » 渗透测试 » Struts2 再爆高危漏洞S2-048 来了   

0.jpg



漏洞名称:
Struts2 远程命令执行漏洞 S2-048

影响版本:

Struts 2.3.x

漏洞等级:

高危

漏洞描述

在Struts 2.3.x  Showcase 插件的ActionMessage 类中,通过构建不可信的输入可实现远程命令攻击。

漏洞成因是当ActionMessage接收客户可控的参数数据时,由于后续数据拼接传递后处理不当导致任意代码执行。

 

解决方案

1、修改传递方式:

通过使用resourcekeys替代将原始消息直接传递给ActionMessage的方式。

如下所示:

messages.add("msg", new ActionMessage("struts1.gangsterAdded", gform.getName()));

而不是:

messages.add("msg", new ActionMessage("Gangster " + gform.getName() + " was added"));

2、升级版本:

关闭Showcase;

升级Struts 2到最新版本(其实如果上次S2-045你升级到了2.5.x,这次就没问题)。

样例与POC


漏洞样例代码如下:

1.jpg

其中gform.getName()用来接收name数据。用户可控,可传入恶意代码。

3.jpg

其中gform.getName()用来接收name数据。用户可控,可传入恶意代码。

%{(#szgx='multipart/form-data').(#dm=@ognl.OgnlContext@DEFA

重点来了,怎么复现!

4.jpg


5.jpg

代码地址 

https://github.com/jas502n/st2-048


如果您喜欢本博客,欢迎点击图片定订阅到邮箱填写您的邮件地址,订阅我们的精彩内容:

正文部分到此结束

文章标签:这篇文章木有标签

版权声明:若无特殊注明,本文皆为( mOon )原创,转载请保留文章出处。

也许喜欢: «记一次境外站渗透过程 | application/json 四种常见的 POST 提交数据方式»

你肿么看?

你还可以输入 250/250 个字

 微笑 大笑 拽 大哭 亲亲 流汗 喷血 奸笑 囧 不爽 晕 示爱 害羞 吃惊 惊叹 爱你 吓死了 呵呵

评论信息框

这篇文章还没有收到评论,赶紧来抢沙发吧~